package model.attivita.complesse;

import model._gestioneeventi.EsecuzioneEnvironment;
import model.attivita.atomiche.TestFineGara;
import model.attivita.atomiche.IscriviCiclista;
import model.attivita.atomiche.AvviaGara;
import model.attivita.atomiche.AggiornaVincitori;
import model.dominio.Ciclista;
import model.dominio.Gara;
import model._framework.TaskExecutor;
import model.attivita.atomiche.SegnaliIO;

public class AttivitaPrincipale implements Runnable {

	private boolean eseguita = false;

	private SegnaliIO segnaliIO;

	public AttivitaPrincipale(SegnaliIO segnaliIO) {
		this.segnaliIO = segnaliIO;
	}

	public synchronized void run() {
		if (eseguita == true) {
			return;
		}
		eseguita = true;

		Gara gara;
		Ciclista ciclista;
		boolean altro;
		boolean inCorso;

		gara = segnaliIO.inserisciDatiGara();
		ciclista = segnaliIO.inserisciDatiCiclista();
		TaskExecutor.getInstance().perform(new IscriviCiclista(gara, ciclista));
		do {
			ciclista = segnaliIO.inserisciDatiCiclista();
			TaskExecutor.getInstance().perform(new IscriviCiclista(gara, ciclista));
			altro = segnaliIO.chiediSeAltroCiclista();
		} while (altro);

		segnaliIO.visualizzaGara(gara);

		TaskExecutor.getInstance().perform(new AvviaGara(gara));
		do {
			try {
				Thread.sleep(100);
			} catch (InterruptedException eccezione) {
				eccezione.printStackTrace();
				System.exit(1);
			}
			TestFineGara testFineGara = new TestFineGara(gara);
			TaskExecutor.getInstance().perform(testFineGara);
			inCorso = testFineGara.getRisultato();
		} while (inCorso);
		EsecuzioneEnvironment.disattivaListener();
		TaskExecutor.getInstance().perform(new AggiornaVincitori(gara));
		segnaliIO.proclamaVincitori(gara);
	}

	public synchronized boolean estEseguita() {
		return eseguita;
	}
}
